import { login,login2,logout, getInfo,getWitta } from "@/api/login";
import { getToken, setToken, removeToken } from "@/utils/auth";

const user = {
  state: {
    token: getToken(),
    name: "",
    orgName: "",
    orgNo: "",
    avatar: "",
    roles: [],
    permissions: [],
    waitta:'',
    homeType:'',
  },

  mutations: {
    HOME_TYPE: (state, homeType) => {
      state.homeType = homeType;
    },
    SET_TOKEN: (state, token) => {
      state.token = token;
    },
    SET_NAME: (state, name) => {
      state.name = name;
    },
    SET_ORGNAME: (state, orgName) => {
      state.orgName = orgName;
    },
    SET_ORGNO: (state, orgNo) => {
      state.orgNo = orgNo;
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar;
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles;
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions;
    },
    SET_WAITTA:(state,waitta)=>{
      state.waitta=waitta
    }
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim();
      const password = userInfo.password;
      const code = userInfo.code;
      const uuid = userInfo.uuid;
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid)
          .then((res) => {
            setToken(res.token);
            commit("SET_TOKEN", res.token);
            resolve();
          })
          .catch((error) => {
            reject(error);
          });
      });
    },
    Login2({ commit }, ticket) {
      return new Promise((resolve, reject) => {
        console.log(1);
        login2(ticket)
          .then((res) => {
            setToken(res.token);
            commit("SET_TOKEN", res.token);
            resolve();
          })
          .catch((error) => {
            reject(error);
          });
      });
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo()
          .then((res) => {
            const user = res.user;
            const avatar =
              user.avatar == "" || user.avatar == null
                ? require("@/assets/images/user.png")
                : process.env.VUE_APP_BASE_API + user.avatar;
            if (res.roles && res.roles.length > 0) {
              // 验证返回的roles是否是一个非空数组
              commit("SET_ROLES", res.roles);
              commit("HOME_TYPE", res.homeType);
              commit("SET_PERMISSIONS", res.permissions);
            } else {
              commit("SET_ROLES", ["ROLE_DEFAULT"]);
            }
            console.log(res,'33333333333333')
            commit("SET_NAME", user.userName);
            commit("SET_ORGNAME", user.orgName);
            commit("SET_ORGNO", user.orgNo);
            commit("SET_AVATAR", avatar);
            resolve(res);
          })
          .catch((error) => {
            reject(error);
          });
      });
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token)
          .then(() => {
            commit("SET_TOKEN", "");
            commit("SET_ROLES", []);
            commit("SET_PERMISSIONS", []);
            removeToken();
            resolve();
          })
          .catch((error) => {
            reject(error);
          });
      });
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise((resolve) => {
        commit("SET_TOKEN", "");
        removeToken();
        resolve();
      });
    },
    //获取任务
    SET_WAITTASKNUM({commit,state}){
      return new Promise((resolve, reject) => {
        getWitta()
          .then((res) => {
            commit("SET_WAITTA", res.data.todoNum);
            resolve();
          })
          .catch((error) => {
            reject(error);
          });
      });
    }
  },
};

export default user;
